Attribute VB_Name = "Module1"
Option Explicit

Private Type Point
    X As Long
    Y As Long
    R As Byte
    G As Byte
    B As Byte
End Type

Private Type BresPoints2D
    X() As Long
    Y() As Long
End Type

Private Declare Function GetPixel Lib "gdi32.dll" (ByVal hdc As Long, ByVal nXPos As Long, ByVal nYPos As Long) As Long
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
  
Private LetterPoints() As Point
Private Points() As Point

Public InProgress As Boolean

Private Sub InitPoints(ByVal Number As Long)

Dim i As Long
Dim Color As Long

ReDim Points(0 To Number) As Point

For i = 0 To Number
    Points(i).X = IMAGEWIDTH * Rnd
    Do Until Points(i).Y > 0
        Points(i).Y = IMAGEHEIGHT * Rnd
    Loop
Next

End Sub

Public Sub AnimateMessage(ByVal Message As String)

Dim ThisLetter As String
Dim i As Long

If InProgress Then Exit Sub

InProgress = True
Form1.MousePointer = vbArrowHourglass

For i = 1 To Len(Message)
    ThisLetter = Mid(Message, i, 1)
    AnimateLetter ThisLetter
    Sleep Val(Form1.Text1)
Next

Form1.MousePointer = vbDefault
InProgress = False

End Sub

Private Sub AnimateLetter(ByVal Letter As String)

Dim i As Long
Dim j As Long
Dim xPix As Long
Dim yPix As Long
Dim Color As Long
Dim DeltaX() As Single
Dim DeltaY() As Single
Dim OldPoints() As Point
Dim STEPS As Long
Dim ThisWidth As Long
Dim ThisHeight As Long

Letter = Mid(Letter, 1, 1)
Form1.Picture2.Cls
Form1.Picture2.ForeColor = &HFFFFFF * Rnd
Form1.Picture2.Print Letter
Form1.Picture2.Refresh

ThisWidth = Form1.Picture2.TextWidth(Letter)
ThisHeight = Form1.Picture2.TextHeight(Letter)

STEPS = Val(Form1.Text2)

ReDim LetterPoints(0 To 1000000) As Point

For yPix = 0 To Form1.Picture2.ScaleHeight
    For xPix = 0 To Form1.Picture2.ScaleWidth
        Color = GetPixel(Form1.Picture2.hdc, xPix, yPix)
        If Color > 0 Then
            LetterPoints(i).X = xPix + ((Form1.Picture1.ScaleWidth \ 2) - (ThisWidth \ 2))
            LetterPoints(i).Y = yPix + ((Form1.Picture1.ScaleHeight \ 2) - (ThisHeight \ 2))

            LetterPoints(i).R = Color And &HFF&
            LetterPoints(i).G = (Color And &HFF00&) \ 256
            LetterPoints(i).B = (Color And &HFF0000) \ 65536
            i = i + 1
        End If
    Next
Next

ReDim Preserve LetterPoints(0 To i - 1) As Point

Call InitPoints(UBound(LetterPoints))

ReDim DeltaX(0 To UBound(LetterPoints)) As Single
ReDim DeltaY(0 To UBound(LetterPoints)) As Single

For i = 0 To UBound(LetterPoints)
    DeltaX(i) = LetterPoints(i).X - Points(i).X
    DeltaY(i) = LetterPoints(i).Y - Points(i).Y
Next

OldPoints = Points

For j = 1 To STEPS
    For i = 0 To UBound(Points)
        Points(i).X = OldPoints(i).X + ((j / STEPS) * DeltaX(i))
        Points(i).Y = OldPoints(i).Y + ((j / STEPS) * DeltaY(i))
    Next

    DoGraph
    DoEvents
Next

End Sub

Private Sub DoGraph()

Dim SA As SAFEARRAY
Dim Offset As Long
Dim i As Long
Dim WidthT3 As Long

WidthT3 = IMAGEWIDTH * 3

With SA
    .cbElements = 1
    .cDims = 1
    .Bounds(0).lLbound = 0
    .Bounds(0).cElements = Bmp.bmWidthBytes * Bmp.bmHeight
    .pvData = Bmp.bmBits
End With

Call CopyMemory(ByVal VarPtrArray(ImageBuffer), VarPtr(SA), 4)

For i = 0 To UBound(ImageBuffer)
    ImageBuffer(i) = 0
Next

For i = 0 To UBound(Points)
    Offset = (IMAGEHEIGHT - Points(i).Y) * WidthT3 + (Points(i).X * 3)
    ImageBuffer(Offset) = LetterPoints(i).B
    ImageBuffer(Offset + 1) = LetterPoints(i).G
    ImageBuffer(Offset + 2) = LetterPoints(i).R
Next

Call CopyMemory(ByVal VarPtrArray(ImageBuffer), 0&, 4)

Form1.Picture1.Refresh

End Sub

Private Sub Swap(Var1, Var2)
    
Var1 = Var1 Xor Var2
Var2 = Var1 Xor Var2
Var1 = Var1 Xor Var2

End Sub

Private Function BresLine(ByVal InitialX As Long, ByVal InitialY As Long, ByVal FinalX As Long, ByVal FinalY As Long) As BresPoints2D

Dim Steep As Boolean
Dim DeltaX As Long
Dim DeltaY As Long
Dim Delta As Long
Dim StepX As Long
Dim StepY As Long
Dim Coord As Long
Dim RetVal As BresPoints2D
ReDim RetVal.X(0 To 600) As Long
ReDim RetVal.Y(0 To 600) As Long
Dim i As Long

Steep = False

DeltaX = Abs(FinalX - InitialX)
If (FinalX - InitialX) > 0 Then
    StepX = 1
Else
    StepX = -1
End If

DeltaY = Abs(FinalY - InitialY)
If (FinalY - InitialY) > 0 Then
    StepY = 1
Else
    StepY = -1
End If

If DeltaY > DeltaX Then
    Steep = True
    Swap InitialX, InitialY
    Swap DeltaX, DeltaY
    Swap StepX, StepY
End If

Delta = (DeltaY * 2) - DeltaX
For Coord = 0 To DeltaX - 1
    
    If Steep Then
        RetVal.X(i) = InitialY
        RetVal.Y(i) = InitialX
    Else
        RetVal.X(i) = InitialX
        RetVal.Y(i) = InitialY
    End If
    i = i + 1
    
    While Delta >= 0
        InitialY = InitialY + StepY
        Delta = Delta - (DeltaX * 2)
    Wend
    
    InitialX = InitialX + StepX
    Delta = Delta + (DeltaY * 2)
Next

RetVal.X(i) = FinalX
RetVal.Y(i) = FinalY

ReDim Preserve RetVal.X(0 To i) As Long
ReDim Preserve RetVal.Y(0 To i) As Long

BresLine = RetVal

End Function
